<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task 23B.60</title>

    <!-- Nhúng thư viện boostrap -->
 <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
 <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css">
 <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.min.js"></script>

</head>
<style>
    .cover-picture {
        background-image: url("LuckyDiceImagesv2023Feb/cover.jpg");
        min-height: 120px;
        margin: 5px;
    }
</style>


<body>

<div class="containter-fluid cover-picture" > <!--Container 1-->
</div>
<br><br>
<div class="container"  > <!--Container 2-->
    <div class="row form-group">
        <div class="col-5 " > <!--User information-->
            <div class="row form-group">
                <h4><span style="color: green">Input your information</span></h4>
                <div class="col-12"> <!--Row 2.1.1.1.1-->

                </div> 
            </div>
            <div class="row form-group">
                <div class="col-4 "> <!--Row 2.1.1.2.1-->
                    <label>User name</label>
                </div>
                <div class="col-8 "> <!--Row 2.1.1.2.2 -->
                    <input id="inp-user-name" class="form-control" type="text">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-4 "> <!--Row 2.1.1.3.1-->
                    <label>Firstname</label></div>
                <div class="col-8 ">  <!--Row 2.1.1.3.2-->
                    <input id="inp-first-name" class="form-control" type="text">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-4 ">  <!--Row 2.1.1.4.1-->
                    <label>Lastname</label>
                </div>
                <div class="col-8 " > <!--Row 2.1.1.4.2-->
                    <input id="inp-last-name" class="form-control" type="text">
                </div>
            </div>
        </div>

        <div class="col-4 " > <!--Playing area-->
            <div class="col-12 text-center form-group "> <!--Row 2.1.2.1-->
                <button id="btn-play" class="btn btn-success" onclick="onPlayButtonClick()">Play</button>
            </div>
            <div class="col-12 form-group "> <!--Row 2.1.2.2-->
                <img id="img-dice" class="img-thumbnail" src="LuckyDiceImagesv2023Feb/dice.png"></p>
            </div>
            <div class="col-12 form-group  text-center"> <!--Row 2.1.2.3-->
                <p id="p-notification-result"><b>Congratulation!!!</b></p>
            </div>
        </div>
        <div class="col-3 text-center "> <!--Present area-->
            <div class="row form-group">
                <div class="col-12 "> <!--Row 2.1.3.1-->
                    <p><span style="color: red"><b>Voucher</b></span></p>
                    <p id="p-voucher-id">No ID</p>
                    <p id="p-voucher-percent">0%</p>
                </div>
            </div>
            <div class="row form-group">
                <div class="col-12 "> <!--Row 2.1.3.2-->
                    <img id="img-present" class="img-thumbnail" src="LuckyDiceImagesv2023Feb/xe-may.jpg">
                </div>
            </div>
            
        </div>
    </div>

    <div class="row form-group text-center form-group"> <!--History buttons-->
        <div class="col-12 "> <!--Row 2.1.1-->
            <button id="btn-dice-history" class="btn btn-success button-width w-25" onclick="diceHistoryClick()">Dice History</button>
            <button id="btn-voucher-history" class="btn btn-warning button-width w-25 ">Voucher History</button>
            <button id="btn-present-history" class="btn btn-info button-width w-25 ">Present History</button>
        </div>
    </div>

    <div class="row "> <!--History table-->
        <div class="col-12"><!--Row 2.3.1-->
            <table id="history-placeholder-table" class="table table-striped table-hover border">
                <thead></thead>
                <tbody></tbody>
            </table>
        </div>
    </div>
</div>

<script>
/***REGION 1 - GLOBAL variables */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice/";
    const vUTF8_TEXT_APPLICATION_HEADER = "application/json; charset=UTF-8";

    const gCOL_TURN = 0;
    const gCOL_DICE = 1;
    const gEND_OF_ROW_COL = -1;

/***REGION 2 - Element handlers */

/***REGION 3 - Event handlers */

    //data collection and validation
    function dataCollectValidate(){
        "use strict";
        //create user object
        var vUserObject = {
            user: "",
            firstname: "",
            lastname: "",

            displayConsoleLog() {
                console.log("%cUSER INFORMATION", "color:orange");
                console.log("Username: " + this.user);
                console.log("Firstname: " + this.firstname);
                console.log("Lastname: " + this.lastname);
            }
        }

        //read data from web form
        readDataWebForm(vUserObject);
        //validate the data
        var vValidResult = validDataWebForm(vUserObject);
        return vUserObject;
    }    

    //add event for Play button
    function onPlayButtonClick(){
        var paramObject = dataCollectValidate();            
        //call API server for playing dice
        var vXmlHttp = new XMLHttpRequest();
        vXmlHttp.open("POST", gBASE_URL + "/dice", true);
        vXmlHttp.setRequestHeader("Content-Type", vUTF8_TEXT_APPLICATION_HEADER);
        vXmlHttp.send(JSON.stringify(paramObject));       
        vXmlHttp.onreadystatechange = function(){
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK){
                processReponse(vXmlHttp);
            }
        }
    }
      
        //function for processing JSON response
        function processReponse(paramResponse){
            console.log(paramResponse.responseText);
            //parsing JSON to object
            var vJsonResponseToObj = JSON.parse(paramResponse.responseText);
            console.log(vJsonResponseToObj)
            
            //display dice image on the web
            changeDice(vJsonResponseToObj);
            //display notification on the web
            changeNofitication(vJsonResponseToObj);
            //display voucher (if any)
            changeVoucher(vJsonResponseToObj);
            //display present (if any)
            changePresent(vJsonResponseToObj);
        }

        //function for displaying the result on the web
        function changeDice(paramDice){
            var vDiceImage = document.getElementById("img-dice")
            switch(paramDice.dice){
                case 1: 
                    vDiceImage.src = "LuckyDiceImagesv2023Feb/1.png";
                break;

                case 2: 
                vDiceImage.src = "LuckyDiceImagesv2023Feb/2.png";
                break;

                case 3: 
                vDiceImage.src = "LuckyDiceImagesv2023Feb/3.png";
                break;

                case 4: 
                vDiceImage.src = "LuckyDiceImagesv2023Feb/4.png";
                break;

                case 5: 
                vDiceImage.src = "LuckyDiceImagesv2023Feb/5.png";
                break;

                default: 
                vDiceImage.src = "LuckyDiceImagesv2023Feb/6.png";
                break;
            }       
        }

        //function for displaying the notification
        function changeNofitication(paramDice){
            var vNotification = document.getElementById("p-notification-result")
            
            if (paramDice.dice <4) {
                vNotification.innerHTML = "Wish you best luck next time - Please try another one!"
            }
            else {
                vNotification.innerHTML = "Congratulation - Let try another one!"
            }
        }

        //function for displaying voucher (if any)
        function changeVoucher (paramDice){
            var vVoucher = document.getElementById("p-voucher-id");
            var vVoucherPercent = document.getElementById("p-voucher-percent");
            
            if (paramDice.voucher != null){
                vVoucher.innerHTML = "Code: " + paramDice.voucher.maVoucher;
                vVoucherPercent.innerHTML = "Sale OFF: " + paramDice.voucher.phanTramGiamGia + "%";
            } 
            else {
                vVoucher.innerHTML = "";
                vVoucherPercent.innerHTML = "";
            }
        }

        //function for displaying present (if any)
        function changePresent(paramDice){
            var vPresent = document.getElementById("img-present")

            switch(paramDice.prize){
                case  "Mũ":
                vPresent.src = "LuckyDiceImagesv2023Feb/hat.jpg"
                break;

                case "Ô tô":
                vPresent.src = "LuckyDiceImagesv2023Feb/car.jpg"
                break;

                case "Xe máy":
                vPresent.src = "LuckyDiceImagesv2023Feb/xe-may.jpg"
                break;

                case "Áo":
                vPresent.src = "LuckyDiceImagesv2023Feb/t-shirt.jpg"
                break;

                case "Áo":
                vPresent.src = "LuckyDiceImagesv2023Feb/t-shirt.jpg"
                break;

                default:
                vPresent.src = "LuckyDiceImagesv2023Feb/no-present.jpg"
                break;
            }
        }

        //function for reading data from the web form
        function readDataWebForm(paramData){

            var vUserElement = document.getElementById("inp-user-name").value;
            var vFirstNameElement = document.getElementById("inp-first-name").value;
            var vLastNameElement = document.getElementById("inp-last-name").value;

            paramData.user = vUserElement.trim();
            paramData.firstname = vFirstNameElement.trim();
            paramData.lastname = vLastNameElement.trim();
        }

        //function for validating the data
        function validDataWebForm(paramData){
        if (paramData.user ==""){
            alert("Please input your username");
            return false;
        }
        if (paramData.firstname ==""){
            alert("Please input your Firstname");
            return false;
        }
        if (paramData.lastname ==""){
            alert("Please input your Lastname");
            return false;
        }
        return true;
        }

//----------------------------------------------------------------------------------------
    //***DICE HISTORY***\\\

    function diceHistoryClick(){
        var vUserObject = dataCollectValidate();
        
        //call API server for getting data of dice history
        var vXmlHttpHistory = new XMLHttpRequest;
            vXmlHttpHistory.open("GET", gBASE_URL + "/dice-history?username=" + vUserObject.user, true);
            vXmlHttpHistory.send();
            vXmlHttpHistory.onreadystatechange = function(){
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK){
                console.log("%cDICE HISTORY", "color: red" , vXmlHttpHistory.responseText);
                displayOnTable(this);
                }
            }
        } 
       
        function displayOnTable(paramData){
    //get the table 
    var vTableHistory = document.getElementById("history-placeholder-table");
    //insert a new row to the "thead"
    var vTabHead = vTableHistory.getElementsByTagName("thead")[0];
    var vNewRowHead = vTabHead.insertRow(gEND_OF_ROW_COL);
        //insert new cells to the "thead"
        var vCellTurnHead = vNewRowHead.insertCell(gCOL_TURN);
        var vCellDiceHead = vNewRowHead.insertCell(gCOL_DICE);
        //put names to the header's cells
        vCellTurnHead.innerHTML = "<b>Turn</b>";
        vCellDiceHead.innerHTML = "<b>Dice</b>";
    
    //parsing the JSON to object
    var vJsonParseObject = JSON.parse(paramData.responseText);
        console.log(vJsonParseObject);
    
    //access the tabs "thead" & "tbody" from the table
    var vTabBody = vTableHistory.getElementsByTagName("tbody")[0];
    
    //insert JSON data into the table
    for (var bI = 0; bI < vJsonParseObject.dices.length; bI++){
        //insert a new row to the "tbody"
        var vNewRowBody = vTabBody.insertRow(gEND_OF_ROW_COL);
        //insert cells to the new row
        var vCellTurn = vNewRowBody.insertCell(gCOL_TURN);
        var vCellDice = vNewRowBody.insertCell(gCOL_DICE);
        //put data to the cells
        vCellTurn.innerHTML = bI + 1;
        vCellDice.innerHTML = vJsonParseObject.dices[bI];
    }
}

/***REGION 4 - Common function */

</script>

</body>
</html>